//
//  UMServerConnection.h
//  ulibserver
//
//  Created by Andreas Fink on 19.07.17.
//  Copyright © 2017 Andreas Fink. All rights reserved.
//

#import <ulib/ulib.h>
#import <ulibasn1/ulibasn1.h>


@class UMServer;
@class UMServerMessage;

@interface UMServerConnection : UMObject
{
    UMSocket *_socket;
    UMServer __weak *_delegate;
    NSMutableData *_inputBuffer;
    BOOL _reconnect;
    UMSocketType _socketType;
    NSString *_remoteHostName;
    int _remotePort;
    BOOL _outgoing;
    NSDate *_lastFailedConnectionAttempt;
}

@property(readwrite,weak,atomic)        UMServer *delegate;
@property(readwrite,strong,atomic)      UMSocket *socket;
@property(readwrite,assign,atomic)      BOOL reconnect;
@property(readwrite,assign,atomic)      BOOL outgoing;
@property(readwrite,strong,atomic)      NSString *remoteHost;
@property(readwrite,assign,atomic)      int remotePort;
@property(readwrite,assign,atomic)      UMSocketType socketType;


- (UMServerConnection *)initWithSocket:(UMSocket *)s server:(UMServer *)server;
- (BOOL)readData; /* returns yes if the socket should be closed */
- (void)close;
- (void)forwardMessage:(UMServerMessage *)msg;
- (UMSocketError)connect;
- (BOOL)isConnected;

@end
