//
//  UMServerMessage.h
//  ulibserver
//
//  Created by Andreas Fink on 19.07.17.
//  Copyright © 2017 Andreas Fink. All rights reserved.
//

#import <ulib/ulib.h>
#import <ulibasn1/ulibasn1.h>

#define UMSERVER_MESSAGE_FLAG_LINK_LOCAL_ONLY        0x01

typedef enum UMServerMessageType
{
    UMServerMessageType_request = 1,
    UMServerMessageType_indication = 2,
    UMServerMessageType_response = 3,
    UMServerMessageType_confirmation = 4,
    UMServerMessageType_abort = 5,
} UMServerMessageType;

@interface UMServerMessage : UMASN1Sequence
{
    UMServerMessageType _messageType;
    NSString    *_sourceAddress;
    NSString    *_destinationAddress;
    int64_t     _sourcePort;
    int64_t     _destinationPort;
    NSData      *_protocolData;
    int64_t     _flags;
    int64_t     _maxHopCount;
}

@property(readwrite,atomic,assign)  UMServerMessageType messageType;
@property(readwrite,atomic,strong)  NSString    *sourceAddress;
@property(readwrite,atomic,strong)  NSString    *destinationAddress;
@property(readwrite,atomic,assign)  int64_t     sourcePort;
@property(readwrite,atomic,assign)  int64_t     destinationPort;
@property(readwrite,atomic,assign)  int64_t     flags;
@property(readwrite,atomic,strong)  NSData      *protocolData;
@property(readwrite,atomic,assign)  int64_t     maxHopCount;

@property(readwrite)  UMASN1Object    *protocolObject;

- (UMServerMessage *)initAsReplyTo:(UMServerMessage *)query;

@end
