//
//  UMServerProviderProtocol.h
//  ulibserver
//
//  Created by Andreas Fink on 26.07.17.
//  Copyright © 2017 Andreas Fink. All rights reserved.
//

#import <ulib/ulib.h>
#import "UMServerUserProtocol.h"

@protocol UMServerProviderProtocol

- (int64_t)newTransactionPort;
- (NSString *)ownAddress;

- (void)startListening:(int64_t)port
               handler:(id<UMServerUserProtocol>)user
               options:(NSDictionary *)options;

- (void)stopListening:(int64_t)port
              handler:(id<UMServerUserProtocol>)user
              options:(NSDictionary *)options;


- (void)request:(UMASN1Object *)msg
    fromAddress:(NSString *)sourceAddress
       fromPort:(int64_t)sourcePort
      toAddress:(NSString *)destinationAddress
         toPort:(int64_t)destinationPort
        options:(NSDictionary *)options
           user:(id<UMServerUserProtocol>)user;

- (void)response:(UMASN1Object *)pdu
     fromAddress:(NSString *)sourceAddress
        fromPort:(int64_t)sourcePort
       toAddress:(NSString *)destinationAddress
          toPort:(int64_t)destinationPort
         options:(NSDictionary *)options
            user:(id<UMServerUserProtocol>)user;


@end
