//
//  UMServerTask_Request.h
//  ulibserver
//
//  Created by Andreas Fink on 26.07.17.
//  Copyright © 2017 Andreas Fink. All rights reserved.
//

#import <ulibasn1/ulibasn1.h>
#import "UMServerUserProtocol.h"

@class UMServer;
@class UMServerConnection;

@interface UMServerTask_Request : UMLayerTask
{

    NSString *_sourceAddress;
    int64_t _sourcePort;
    NSString *_destinationAddress;
    int64_t _destinationPort;
    UMASN1Object *_pdu;
    NSDictionary *_options;
    UMServer *_server;
    id<UMServerUserProtocol> _user;
    UMServerConnection *_forcedConnection;
}

- (UMServerTask_Request *)initWithRequest:(UMASN1Object *)msg
                              fromAddress:(NSString *)sourceAddress
                                 fromPort:(int64_t)sourcePort
                                toAddress:(NSString *)destinationAddress
                                   toPort:(int64_t)destinationPort
                                  options:(NSDictionary *)options
                                   server:(UMServer *)srv
                                     user:(id<UMServerUserProtocol>)user;

@property(readwrite,strong,atomic)   UMServerConnection *forcedConnection;
@end
