//
//  UMServerUserProtocol.h
//  ulibserver
//
//  Created by Andreas Fink on 26.07.17.
//  Copyright © 2017 Andreas Fink. All rights reserved.
//

#import <ulib/ulib.h>

@protocol UMServerUserProtocol

- (void)indication:(UMASN1Object *)pdu
       fromAddress:(NSString *)sourceAddress
          fromPort:(int64_t)sourcePort
         toAddress:(NSString *)destinationAddress
            toPort:(int64_t)destinationPort
           options:(NSDictionary *)options;

- (void)confirm:(UMASN1Object *)pdu
    fromAddress:(NSString *)sourceAddress
       fromPort:(int64_t)sourcePort
      toAddress:(NSString *)destinationAddress
         toPort:(int64_t)destinationPort
        options:(NSDictionary *)options;

- (void)abortWithError:(UMASN1Object *)err
           fromAddress:(NSString *)sourceAddress
              fromPort:(int64_t)sourcePort
             toAddress:(NSString *)destinationAddress
                toPort:(int64_t)destinationPort
               options:(NSDictionary *)options;

@end
